package com.cmss.pretendProxy;

import java.io.Closeable;
import java.util.HashMap;
import java.util.Map;

import javax.net.ServerSocketFactory;
import javax.net.SocketFactory;

import org.apache.log4j.Logger;

public abstract class ProxyServer extends Thread {

    private static final Logger LOGGER = Logger.getLogger(ProxyServer.class);

    final static String cuttingLine = "==============================";

    final static String server2proxy = "服务端--->代理";

    final static String proxy2server = "代理--->服务端";

    final static String proxy2client = "代理--->客户端";

    final static String client2proxy = "客户端--->代理";

    final static String server2client = "服务端--->客户端";

    final static String client2server = "客户端--->服务端";

    final static String CRLF = "\r\n";

    final static int DATABUFFERSIZE = 512;

    //端口列表
    final Map lastPorts = new HashMap();

    String logPrefix = "";

    String logPostfix = "";

    Configuration config;

    /** The socket's SocketFactory. */
    SocketFactory _socketFactory_;

    /** The socket's ServerSocket Factory. */
    ServerSocketFactory _serverSocketFactory_;

    public void setConfig(final Configuration config) {

        this.config = config;
    }

    /**
     * 调试日志
     */
    public void debugLog(final String msg) {

        LOGGER.debug(logPrefix + msg + logPostfix);

    }

    /**
     * 普通日志
     */
    public void infoLog(final String msg) {

        LOGGER.info(logPrefix + msg + logPostfix);

    }

    /**
     * 错误日志
     */
    public void errorLog(final String msg, final Exception e) {

        LOGGER.error(logPrefix + msg + logPostfix, e);

    }

    /**
     * 关闭连接
     *
     * @param o
     * @param msg
     */
    public void close(final Object o, final String msg) {

        if (o != null && o instanceof Closeable) {
            try {
                ((Closeable) o).close();
            } catch (final Exception e) {
                errorLog("关闭" + msg + "异常", e);
            }
        }
    }
}
