/*------------------------------------------------------------------------------
 *******************************************************************************
 * COPYRIGHT China Mobile (SuZhou) Software Technology Co.,Ltd. 2017
 *
 * The copyright to the computer program(s) herein is the property of
 * CMSS Co.,Ltd. The programs may be used and/or copied only with written
 * permission from CMSS Co.,Ltd. or in accordance with the terms and conditions
 * stipulated in the agreement/contract under which the program(s) have been
 * supplied.
 *******************************************************************************
 *----------------------------------------------------------------------------*/
package com.cmss.pretendProxy;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import org.apache.commons.net.ftp.FTPClient;
import org.apache.commons.net.ftp.FTPFile;
import org.apache.commons.net.ftp.FTPReply;

public class FtpsProxyTest {

    public static void main(final String[] args) throws Exception {

        //        testConnect();

        //        testList();

        //        testUpload();

        testDownload();
    }

    /**
     * 测试连接代理服务器 和 登录
     */
    public static void testConnect() {

        //        final FTPSClient ftpClient = new FTPSClient(false);
        final FTPClient ftpClient = new FTPClient();

        try {
            int reply;

            // 代理服务器IP和端口
            ftpClient.connect("127.0.0.1", 8091);

            // 登录名：FTP服务器用户名@FTP服务器IP:端口，密码：FTP服务器用户名对应的密码
            ftpClient.login("eshub@10.139.5.112:21", "eshub");
            reply = ftpClient.getReplyCode();

            System.out.println("reply:" + reply);

            if (!FTPReply.isPositiveCompletion(reply)) {
                ftpClient.disconnect();
                return;
            }

            ftpClient.logout();
        } catch (final IOException e) {
            e.printStackTrace();
        } finally {
            if (ftpClient.isConnected()) {
                try {
                    ftpClient.disconnect();
                } catch (final IOException ioe) {
                }
            }
        }
    }

    /**
     * 测试list目录
     */
    public static void testList() {

        final FTPClient ftpClient = new FTPClient();
        //        final FTPSClient ftpClient = new FTPSClient();
        try {
            int reply;
            // 代理服务器IP和端口
            ftpClient.connect("127.0.0.1", 8091);
            // 登录名：FTP服务器用户名@FTP服务器IP:端口，密码：FTP服务器用户名对应的密码
            ftpClient.login("eshub@10.139.5.112:21", "eshub");

            reply = ftpClient.getReplyCode();

            System.out.println("reply:" + reply);

            if (!FTPReply.isPositiveCompletion(reply)) {
                ftpClient.disconnect();
                return;
            }
            //            ftpClient.changeWorkingDirectory("/");// 转移到FTP服务器目录

            ftpClient.enterLocalPassiveMode();
            ftpClient.setFileType(FTPClient.BINARY_FILE_TYPE);
            ftpClient.setControlEncoding("UTF-8");

            final FTPFile[] fs = ftpClient.listFiles();
            System.out.println("size:" + fs.length);
            for (int i = 0; i < fs.length; i++) {
                System.out.println(fs[i].getName());
            }

            ftpClient.logout();
        } catch (final IOException e) {
            e.printStackTrace();
        } finally {
            if (ftpClient.isConnected()) {
                try {
                    ftpClient.disconnect();
                } catch (final IOException ioe) {
                }
            }
        }
    }

    /**
     * 测试upload
     */
    public static void testUpload() {

        final FTPClient ftpClient = new FTPClient();

        try {
            int reply;
            // 代理服务器IP和端口
            ftpClient.connect("127.0.0.1", 8091);
            // 登录名：FTP服务器用户名@FTP服务器IP:端口，密码：FTP服务器用户名对应的密码
            ftpClient.login("eshub@10.139.5.112:21", "eshub");
            reply = ftpClient.getReplyCode();

            System.out.println("reply:" + reply);

            if (!FTPReply.isPositiveCompletion(reply)) {
                ftpClient.disconnect();
                return;
            }
            // ftpClient.changeWorkingDirectory("/");// 转移到FTP服务器目录

            ftpClient.enterLocalPassiveMode();
            ftpClient.setFileType(FTPClient.BINARY_FILE_TYPE);
            ftpClient.setControlEncoding("UTF-8");

            final FTPFile[] fs = ftpClient.listFiles();
            System.out.println("上传前size:" + fs.length);
            for (int i = 0; i < fs.length; i++) {
                System.out.println(fs[i].getName());
            }

            InputStream in = null;
            // Upload.
            try {
                final File file = new File("E:/testProxy.txt");

                // Use passive mode to pass firewalls.
                ftpClient.enterLocalPassiveMode();

                final String ftpFileName = "testProxy1.txt";

                in = new BufferedInputStream(new FileInputStream(file));
                if (!ftpClient.storeFile(ftpFileName, in)) {
                    throw new IOException("Can't upload file '" + ftpFileName
                            + "' to FTP server. Check FTP permissions and path.");
                }

            } finally {
                try {
                    if (in != null) {
                        in.close();
                    }
                } catch (final IOException ex) {
                }
            }

            final FTPFile[] fs1 = ftpClient.listFiles();
            System.out.println("上传后size:" + fs1.length);
            for (int i = 0; i < fs1.length; i++) {
                System.out.println(fs1[i].getName());
            }

            ftpClient.logout();
        } catch (final IOException e) {
            e.printStackTrace();
        } finally {
            if (ftpClient.isConnected()) {
                try {
                    ftpClient.disconnect();
                } catch (final IOException ioe) {
                }
            }
        }
    }

    /**
     * 测试download
     */
    public static void testDownload() {

        final FTPClient ftpClient = new FTPClient();

        try {
            int reply;
            // 代理服务器IP和端口
            ftpClient.connect("127.0.0.1", 8091);
            // 登录名：FTP服务器用户名@FTP服务器IP:端口，密码：FTP服务器用户名对应的密码
            ftpClient.login("eshub@10.139.5.112:21", "eshub");
            reply = ftpClient.getReplyCode();

            System.out.println("reply:" + reply);

            if (!FTPReply.isPositiveCompletion(reply)) {
                ftpClient.disconnect();
                return;
            }

            // Download.
            OutputStream out = null;
            try {
                // Use passive mode to pass firewalls.
                ftpClient.enterLocalPassiveMode();
                ftpClient.setFileType(FTPClient.BINARY_FILE_TYPE);
                ftpClient.setControlEncoding("UTF-8");

                final File localFile = new File("E:/textDownload.txt");
                final String ftpFileName = "testProxy1.txt";

                // Download file.
                out = new BufferedOutputStream(new FileOutputStream(localFile));
                if (!ftpClient.retrieveFile(ftpFileName, out)) {
                    throw new IOException("Error loading file " + ftpFileName
                            + " from FTP server. Check FTP permissions and path.");
                }

                out.flush();
            } finally {
                if (out != null) {
                    try {
                        out.close();
                    } catch (final IOException ex) {
                    }
                }
            }

            ftpClient.logout();
        } catch (final IOException e) {
            e.printStackTrace();
        } finally {
            if (ftpClient.isConnected()) {
                try {
                    ftpClient.disconnect();
                } catch (final IOException ioe) {
                }
            }
        }
    }

}
